<script setup lang="ts">
import type { BaseCopyCards, BaseCopyImage } from '@/types/base';
import {
  AutoScale,
  AutomatedCode,
  Release,
  ChevronLgRight,
  Devsecops,
  RemoteWorld,
  Visibility,
} from 'slippers-ui/icons';

defineProps<BaseCopyCards & BaseCopyImage>();

const scrollingBlock = useTemplateRef('scrollingBlock');
const scrollingBlockParent = useTemplateRef('scrollingBlockParent');

const { isMobile } = useCheckIfMobile();
const pageProgress = ref(8);

const icons = {
  AutoScale,
  AutomatedCode,
  Devsecops,
  Release,
  RemoteWorld,
  Visibility,
};

/*
 Component's methods
 */
const getElementDistance = (elem) => {
  let location = 0;
  while (elem && elem.offsetParent) {
    location += elem.offsetTop;
    elem = elem.offsetParent;
  }
  return Math.max(location, 0);
};

const updatePageProgress = () => {
  const scrollSection = scrollingBlock.value;
  if (!scrollSection) return;

  const elementDistanceFromTop = getElementDistance(scrollSection);
  const currentPosition = window.scrollY;
  const elementHeight = scrollSection.clientHeight;

  if (elementDistanceFromTop < currentPosition + 120 && currentPosition < elementDistanceFromTop + elementHeight) {
    const percent = ((currentPosition - elementDistanceFromTop) / elementHeight) * 100 + 15;
    pageProgress.value = Math.min(percent, 100);
  }
};

/*
  Lifecycle methods
 */
onMounted(() => {
  window.addEventListener('scroll', updatePageProgress);

  const container = scrollingBlockParent.value.$el;
  if (!container) return;

  const observer = new IntersectionObserver(
    (entries) => {
      entries.forEach((entry) => {
        entry.target.classList.toggle('scrolling-block__content--active', entry.isIntersecting);
        entry.target.setAttribute('aria-disabled', entry.target.ariaDisabled ? 'true' : 'false');
      });
    },
    {
      threshold: isMobile ? 0.2 : 0.4,
      rootMargin: '-120px',
    },
  );

  Array.from(container.children).forEach((child) => observer.observe(child));
});

onUnmounted(() => {
  window.removeEventListener('scroll', updatePageProgress);
});
</script>

<template>
  <SlpSection>
    <div class="scrolling-block">
      <SlpRow>
        <SlpColumn :cols="8">
          <SlpTypography tag="h2" variant="heading2-bold" class="slp-mb-8">{{ title }}</SlpTypography>
          <SlpTypography v-if="description" tag="p" variant="body1" class="slp-mb-96">{{ description }}</SlpTypography>
        </SlpColumn>
      </SlpRow>
      <div ref="scrollingBlock" class="scrolling-block__scroll">
        <SlpColumn :cols="1">
          <div class="scrolling-block__progress-container">
            <div class="scrolling-block__progress-bar" :style="{ height: `${pageProgress}%` }" />
          </div>
        </SlpColumn>
        <SlpColumn ref="scrollingBlockParent" :cols="5">
          <div v-for="card in cards" :key="card.title" class="scrolling-block__content">
            <SlpIcon v-if="card.config?.icon" :icon="icons[card.config.icon]" size="md" />
            <SlpTypography tag="h3" variant="heading3-bold" class="slp-my-8">{{ card.title }}</SlpTypography>
            <SlpTypography tag="div" variant="body1" class="slp-mb-8">{{ card.description }}</SlpTypography>

            <div class="slp-mb-64">
              <SlpButton
                v-if="card.button && card.button.config"
                variant="tertiary"
                :aria-label="card.button.config.dataGaName"
                :data-ga-name="card.button.config.dataGaName"
                :data-ga-location="card.button.config.dataGaLocation"
                :href="card.button.config.href"
                >{{ card.button.text }}
                <SlpIcon :icon="ChevronLgRight" />
              </SlpButton>
            </div>
          </div>
        </SlpColumn>
        <SlpColumn :cols="4" class="scrolling-block__img-col">
          <img v-if="image" :src="image.config.src" :alt="image.altText" loading="lazy" />
        </SlpColumn>
      </div>
    </div>
  </SlpSection>
</template>

<style scoped lang="scss">
.scrolling-block {
  margin-bottom: $spacing-96;
  padding-top: $spacing-16;

  &__content {
    padding-right: $spacing-16;
    opacity: 0.6;

    @media (width < $breakpoint-md) {
      padding-left: $spacing-64;
    }

    &--active {
      opacity: 1 !important;
    }
  }

  &__scroll {
    display: flex;
    flex-wrap: wrap;
    position: relative;
    transition: opacity 0.2s;
  }

  &__img-col {
    img {
      position: sticky;
      top: 160px;
      max-width: 100%;
    }

    @media (width < $breakpoint-md) {
      display: none;
    }
  }

  &__progress-container {
    width: 2px;
    background: $color-surface-200;
    position: absolute;
    top: 0;
    bottom: 0;
    left: 0;
  }

  &__progress-bar {
    position: absolute;
    background: $color-surface-700;
    width: 2px;
  }
}
</style>
